<!--
  ~ EVS Client is part of the Gazelle Test Bed
  ~ Copyright (C) 2006-2016 IHE
  ~ mailto :eric DOT poiseau AT inria DOT fr
  ~
  ~ See the NOTICE file distributed with this work for additional information
  ~ regarding copyright ownership.  This code is licensed
  ~ to you under the Apache License, Version 2.0 (the
  ~ "License"); you may not use this file except in compliance
  ~ with the License.  You may obtain a copy of the License at
  ~
  ~   http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing,
  ~ software distributed under the License is distributed on an
  ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~ KIND, either express or implied.  See the License for the
  ~ specific language governing permissions and limitations
  ~ under the License.
  -->

<ui:composition xmlns:h="http://java.sun.com/jsf/html" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:rich="http://richfaces.org/rich" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml">
    <!-- This template must be included using a s:decorate element in a <ui:define name="body"> element, following elements maybe included: specificFilters, specificColumns -->
    <!-- parameters: managedBean
                       result table uses "data" as var attribute-->
    <h:form id="globalForm">
        <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">

            <h:inputHidden id="standard" name="standard" value="#{managedBean.standardId}"/>
            <h:inputHidden id="filterUrlParameters" name="filterUrlParameters" value="#{managedBean.filter.urlParameters}"/>
            <script>
                updateUrl("globalForm:filterUrlParameters");
                jq162("#globalForm\\:filterUrlParameters").bind('change',
                    function () {
                        updateUrl("globalForm:filterUrlParameters");
                    });
            </script>
            <a4j:queue requestDelay="300" ignoreDupResponses="true"/>

            <ui:param name="panel_id" value="criteriaDiv"/>
            <ui:define name="panel_title">
                <h:outputText value="#{messages['net.ihe.gazelle.assets.SearchCriteria']}"/>
            </ui:define>

            <div class="row">

                <div class="col-lg-8">
                    <s:decorate template="/layout/form/_edit.xhtml" rendered="#{managedBean.startDate != null}">
                        <ui:define name="label">#{messages['net.ihe.gazelle.evs.ValidationDateFrom']}</ui:define>
                        <g:date date="true" time="true" value="#{managedBean.startDate}" tooltip="false"/>
                    </s:decorate>
                    <gdk:spacer width="10px"/>
                    <s:decorate template="/layout/form/_edit.xhtml" rendered="#{managedBean.endDate != null}">
                        <ui:define name="label">#{messages['net.ihe.gazelle.evs.To']}</ui:define>
                        <g:date date="true" time="true" value="#{managedBean.endDate}" tooltip="false"/>
                    </s:decorate>
                </div>

                <div class="col-lg-8">
                  <ui:include src="/filter/filterDate.xhtml">
                        <ui:param name="filter" value="#{managedBean.filter}"/>
                        <ui:param name="filterId" value="date"/>
                        <ui:param name="filterName" value="#{messages['net.ihe.gazelle.evs.Date']}"/>
                        <ui:param name="filterForm" value="globalForm"/>
                    </ui:include>
                </div>

                <div class="col-lg-8">
                    <ui:include src="/filter/filter.xhtml">
                        <ui:param name="filter" value="#{managedBean.filter}"/>
                        <ui:param name="filterId" value="validationStatus"/>
                        <ui:param name="filterName"
                                  value="#{messages['net.ihe.gazelle.evs.ValidationStatus']}"/>
                        <ui:param name="filterForm" value="globalForm"/>
                    </ui:include>
                </div>

                <div class="col-lg-8">
                    <ui:include src="/filter/filter.xhtml">
                        <ui:param name="filter" value="#{managedBean.filter}"/>
                        <ui:param name="filterId" value="entryPoint"/>
                        <ui:param name="filterName" value="#{messages['net.ihe.gazelle.evs.EntryPoint']}"/>
                        <ui:param name="filterForm" value="globalForm"/>
                    </ui:include>
                </div>

                <s:div rendered="#{s:hasRole('monitor_role') or s:hasRole('admin_role')}">
                    <div class="col-lg-8">

                        <ui:include src="/filter/filter.xhtml">
                            <ui:param name="filter" value="#{managedBean.filter}"/>
                            <ui:param name="filterId" value="privateUser"/>
                            <ui:param name="filterName" value="#{messages['gazelle.evs.client.validation.user']}"/>
                            <ui:param name="filterForm" value="globalForm"/>
                        </ui:include>
                    </div>

                    <div class="col-lg-8">
                        <ui:include src="/filter/filter.xhtml">
                            <ui:param name="filter" value="#{managedBean.filter}"/>
                            <ui:param name="filterId" value="institutionKeyword"/>
                            <ui:param name="filterName" value="#{messages['net.ihe.gazelle.evs.Organization']}"/>
                            <ui:param name="filterForm" value="globalForm"/>
                        </ui:include>
                    </div>
                </s:div>
                <ui:insert name="specificFilters"/>
            </div>

            <ui:define name="filter_buttons">
                <a4j:commandLink title="#{messages['net.ihe.gazelle.evs.ResetFilters']}"
                                 actionListener="#{managedBean.reset()}"
                                 render="globalForm">
                    <span class="gzl-icon-times-circle"></span>
                </a4j:commandLink>
            </ui:define>


        </ui:decorate>

        <s:div id="resultDiv">
            <rich:dataTable id="resultDataTable" value="#{managedBean.dataModel}" var="data"
                            rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                            styleClass="table table-striped  table-responsive" render="ds">
                <g:column rendered="#{identity.loggedIn}">
                    <s:span styleClass="gzl-icon-link" rendered="#{not empty data.sharing.privacyKey}"
                        title="#{messages['gazelle.evs.ThisValidationReportIsShared']}"/>
                    <s:span styleClass="gzl-icon-lock" rendered="#{data.sharing.isPrivate and empty data.sharing.privacyKey}"
                        title="#{messages['gazelle.evs.ThisValidationReportIsPrivate']}"/>
                    <s:span styleClass="gzl-icon-unlock" rendered="#{not data.sharing.isPrivate}"
                        title="#{messages['gazelle.evs.ThisValidationReportIsPublic']}"/>
                </g:column>
                <g:column sortBy="#{'oid'}" filterBy="#{'oid'}">
                    <ui:define name="header">#{messages['gazelle.evs.client.saml.oid']}</ui:define>
                    <h:outputLink id="link1" value="#{managedBean.getPermanentLink(data)}">
                        <h:outputText value="#{data.oid}"/>
                    </h:outputLink>
                </g:column>
                <g:column sortBy="#{'date'}" sortOrder="descending">
                    <ui:define name="header">#{messages['net.ihe.gazelle.evs.ValidationDate']}</ui:define>
                    <g:date date="true" time="true" value="#{data.date}" tooltip="false"/>
                </g:column>
                <g:column sortBy="#{'caller.entryPoint'}">
                    <ui:define name="header">#{messages['net.ihe.gazelle.evs.EntryPoint']}</ui:define>
                    <h:outputText value="#{data.caller.entryPoint}"/>
                </g:column>
                <ui:insert name="specificColumns"/>
                <g:column sortBy="#{'owner.username'}" rendered="#{identity.loggedIn}">
                    <ui:define name="header">#{messages['gazelle.evs.client.validation.user']}</ui:define>
                    <h:outputText value="#{managedBean.getUserName(data.owner.username)}"/>
                </g:column>
                <g:column sortBy="#{'owner.organization'}" filterBy="#{'owner.organization'}" rendered="#{identity.loggedIn}">
                    <ui:define name="header">#{messages['net.ihe.gazelle.evs.Organization']}</ui:define>
                    <h:outputText value="#{data.owner.organization}"/>
                </g:column>
                <g:column sortBy="#{'validationService.name'}" filterBy="#{'validationService.name'}">
                    <ui:define name="header">#{messages['net.ihe.gazelle.evs.ValidationService_2']}</ui:define>
                    <h:outputText value="#{data.validationService.name}"/>
                </g:column>
                <g:column sortBy="#{'validationService.validatorKeyword'}" filterBy="#{'validationService.validatorKeyword'}">
                    <ui:define name="header">#{messages['net.ihe.gazelle.mca.Validator']}</ui:define>
                    <h:outputText value="#{data.validationService.validatorKeyword}"/>
                </g:column>
                <g:column sortBy="#{'validationService.validatorVersion'}" filterBy="#{'validationService.validatorVersion'}">
                    <ui:define name="header">#{messages['net.ihe.gazelle.evs.ValidatorVersion']}</ui:define>
                    <h:outputText value="#{data.validationService.validatorVersion}"/>
                </g:column>
                <g:column sortBy="#{'validationStatus'}" >
                    <ui:define name="header">#{messages['net.ihe.gazelle.evs.ValidationStatus']}</ui:define>
                    <h:outputText value="#{data.validationStatus}" styleClass='#{data.validationStatus}'/>
                </g:column>
                <g:column rendered="#{s:hasRole('admin_role')}">
                    <ui:define name="header">#{messages['gazelle.common.Action']}</ui:define>

                    <a4j:commandLink
                            title="#{messages['net.ihe.gazelle.evs.Delete']}" oncomplete="jq162('#delete_log').modal('show');"
                            actionListener="#{validationBrowserBeanGui.setSelectedValidationForDeletion(data)}" render="delete_log_form">
                        <s:span styleClass="gzl-icon-trash-o  text-info"/>
                    </a4j:commandLink>
                </g:column>



                <f:facet name="footer">
                    <ui:include src="/util/datatableFooter.xhtml">
                        <ui:param name="dataScrollerId" value="ds"/>
                        <ui:param name="dataTableId" value="resultDataTable"/>
                    </ui:include>
                </f:facet>
            </rich:dataTable>
        </s:div>
    </h:form>


    <h:form id="delete_log_form">
        <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
            <ui:param name="popup_id" value="delete_log"/>
            <ui:define name="popup_title">
                <h:outputText value="#{messages['net.ihe.gazelle.evs.Delete']}"/>
            </ui:define>
            <h:outputText value="#{messages['gazelle.evs.client.AreYouSureYouWantToDeleteThisLog']}"/>
            <h:outputText value=" (#{validationBrowserBeanGui.getSelectedValidationForDeletion().getOid()})"/>
            <ui:define name="popup_footer">
                <a4j:commandButton styleClass="gzl-btn"
                                   value="#{messages['net.ihe.gazelle.uploader.cancelCaption']}"
                                   oncomplete="jq162('#delete_log').modal('hide');"
                                   execute="@this"/>
                <a4j:commandButton value="#{messages['gazelle.evs.client.Confirm']}"
                                   actionListener="#{validationBrowserBeanGui.deleteSelectedObject()}"
                                   onclick="jq162('#delete_log').modal('hide');"
                                   styleClass="gzl-btn-red"
                                   execute="@this" render="resultDiv" />
            </ui:define>
        </ui:decorate>
    </h:form>
</ui:composition>
